' EXCLUSIV file lock checker v1.0 21-Dec-92 by Monte Ferguson.
'
'
' Quick and dirty program to determine if you can get exclusive access to a
' file. Usage:

' EXCLUSIV filename [/R] [/W]
'
' where "filename" is the name of the file to be checked (duh!),
' /R and /W tell what kind of exclusivity to check for: /R=Read, /W=Write.
' Default is /W.
'
' Returns DOS ERRORLEVEL of...
'
' 0 if you CAN get exclusive use of a file
' 1 if you CAN'T.
' 2 if the file can't be opened (bad file name?)
' 3 if the program doesn't know what the hell you want from it
' 255 if an error occurs (bug! That'll never happen :-)

' This ain't elegant, but it works, y'know?

DEFINT A-Z

ON ERROR GOTO ErrHandler                ' Like, the crux.

c$ = LTRIM$(RTRIM$(UCASE$(COMMAND$)))   ' UCASE is redundant, but what the hey

LockType = 0                            ' Start with no assumption

i = INSTR(c$, "/R")                     ' Look for /R switch
IF i > 0 THEN
  LockType = LockType + 1               ' Found it...
  c$ = LEFT$(c$, i - 1) + MID$(c$, i + 3)' Remove the switch from command line
END IF

i = INSTR(c$, "/W")                     ' Look for /W switch
IF i > 0 THEN
  LockType = LockType + 2                ' Found it...
  c$ = LEFT$(c$, i - 1) + MID$(c$, i + 3)' Remove the switch from command line
END IF

IF LEN(Lock$) < 1 THEN
  LockType = 2                          ' Default = /W
END IF

' Assume rest of command line is file name...
c$ = LTRIM$(RTRIM$(c$))

IF LEN(c$) = 0 THEN                     ' No file name! User must need help.
  PRINT " EXCLUSIV v 1.0 by Monte Ferguson 21-Dec-92"
  PRINT
  PRINT "Tells if a file can be locked exclusively by you. Usage:"
  PRINT "  EXCLUSIV filename [/R] [/W]"
  PRINT " where filename is the file to be checked, /R and /W control the lock type"
  PRINT " to check (read and/or write), default is /W."
  PRINT "Returns ERRORLEVEL of 0 if you CAN lock, 1 if you CAN'T, 2 if you give a bad file"
  PRINT "name, 3 if the program doesn't know what you want from it (like RIGHT NOW!),"
  PRINT "255 if there's a bug."
  PRINT
  PRINT "Program ends because I don't know what you want me to do."
  END 3
END IF

SELECT CASE LockType
  CASE 1                                ' /R
    OPEN c$ FOR INPUT LOCK READ AS #1
  CASE 2                                ' /W
    OPEN c$ FOR INPUT LOCK WRITE AS #1
  CASE 3
    OPEN c$ FOR INPUT LOCK READ WRITE AS #1
  CASE ELSE
    PRINT "Ambigous lock type. Behold, I croak. Ack!"
    END
END SELECT
' If we got this far we were allowed to open with that lock type, so clean
'up and end with a zero.
CLOSE
PRINT c$; " can be locked exclusively."
END 0

ErrHandler:
' ------------------------------------------------------------------------
' We only get here if we WEREN'T allowed to open with that lock type, OR
' the program bombed.
' ------------------------------------------------------------------------
SELECT CASE ERR
  CASE 70                   ' "Permission Denied", what we're looking for
    PRINT c$; " is locked by some other process."
    END 1
  CASE 53, 52, 64           ' "File not found" or "Bad filename"
    PRINT c$; " is a bad file name, or isn't here."
    END 2
  CASE ELSE
    PRINT "Program Error "; ERR
    PRINT "Money-back refund if not delighted!"
    END 255
END SELECT

